
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>
#include <dlfcn.h>

#include <botnet.h>

#include "cbot.h"

#define debug( fmt, arg... )	\
	do{ if( opt_debug ) printf( fmt, ##arg ); }while(0)

extern struct _event_callback **root_callback;
extern int opt_debug;
extern char *opt_diraddon;

int parse_line( char **pstr, char ***argv )
{
	char *str;
	int argc;
	int str_scan;
	char quote;
	int argv_size = 5;

	str = *pstr;

	*argv = (char**)malloc( sizeof(char*)*argv_size );
	if( *argv == NULL )
		fprintf( stderr, "malloc failed.(%s)\n", strerror(errno) );
		return 0;

retry:
	argc = 0;
	str_scan = 0;

	while( 1 )
	{
		/* skip empty space */
		while( str[str_scan] != 0 )
		{
			if( !isspace(str[str_scan]) )
				break;
			str_scan++;
		}
		//debug( "str_scan %d\n", str_scan );
		if( str[str_scan] == 0 )
			break;
		//debug( "str_scan %d\n", str_scan );

		/* store argument pointer */
		if( (str[str_scan]=='\'') || (str[str_scan]=='\"') )
			quote = str[str_scan++];
		else
			quote = 0;
		(*argv)[argc] = &str[str_scan];

		/* find end of argument */
		if( quote != 0 )
		{
			while( str[str_scan] != 0 )
			{
				if( str[str_scan] == quote )
					break;
				str_scan ++;
			}
			argc ++;
			if( str[str_scan] == 0 )
				break;
			else
				str[str_scan] = 0;
		}
		else
		{
			while( str[str_scan] != 0 )
			{
				if( isspace(str[str_scan]) )
					break;
				str_scan ++;
			}
			argc ++;
			if( str[str_scan] == 0 )
				break;
			else
				str[str_scan] = 0;
		}

		str_scan ++;

		/* resize the vector array if needed */
		if( argc+1 > argv_size )
		{
			//debug( "resize argv\n" );
			argv_size += 5;
			*argv = (char**)realloc( *argv, sizeof(char*)*argv_size );
			if( argv == NULL )
			{
				fprintf( stderr, "realloc failed.(%s)\n", strerror(errno) );
				return 0;
			}
		}
	}

	if( argc > 0 )
	{
		*argv = (char**)realloc( *argv, sizeof(char*)*(argc+1) );
		(*argv)[argc] = NULL;
	}
	else
	{
		free( *argv );
		*argv = NULL;
	}

failed_realloc:
	*pstr = str;

	return argc;
}

void parse_line_free( char **argv )
{
	free( argv );
}

static int def_list_event( BN_PInfo I, const char **args )
{
	int a;
	char nick[64];

	BN_ExtractNick( args[0], nick, 64 );

	for( a=0; root_callback[a]; a++ )
	{
		event_callback_t *tmp = root_callback[a];
		char str[strlen(tmp->eventname)+32];

		if( a )
			BN_SendPrivateMessage( I, nick, "\n" );
		sprintf( str, "in event \"%s\"\n", tmp->eventname );
		BN_SendPrivateMessage( I, nick, str );
		do
		{
			char str[strlen(tmp->name)+32];

			sprintf( str, "- %s", tmp->name );
			BN_SendPrivateMessage( I, nick, str );
			tmp = tmp->next;
		}
		while( tmp );
	}

	BN_SendPrivateMessage( I, nick, "done." );

	return 1;
}

int plugin_filter( const struct dirent *ent )
{
	if( ent->d_name[0] == '.' )
		return 0;

	return 1;
}

static int def_list_plugindir( BN_PInfo I, const char **args )
{
	struct dirent **namelist;
	char nick[64];
	int n;
	int a;

	BN_ExtractNick( args[0], nick, 64 );

	n = scandir( opt_diraddon, &namelist, plugin_filter, alphasort );
	if( n < 0 )
	{
		BN_SendPrivateMessage( I, nick, "scandir failed." );
		BN_SendPrivateMessage( I, nick, strerror(errno) );

		return 1;
	}

	BN_SendPrivateMessage( I, nick, "addon directory...\n" );
	if( n )
	{
		for( a=0; a<n; a++ )
		{
			char buf[strlen(namelist[a]->d_name)+16];

			sprintf( buf, "- %s", namelist[a]->d_name );
			BN_SendPrivateMessage( I, nick, buf );
			free( namelist[a] );
		}
	}
	else
		BN_SendPrivateMessage( I, nick, "is empty..." );

	free( namelist );

	BN_SendPrivateMessage( I, nick, "done." );

	return 1;
}

static int def_exit( BN_PInfo I, const char **args )
{
	exit( 0 );
}

struct addons_s
{
	void *handle;
	char *filename;
} *addons;

static int def_attach( BN_PInfo I, const char *name, const char **args )
{
	void *handle;
	char nick[64];
	char filename[strlen(name) + 32];

	BN_ExtractNick( args[0], nick, 64 );

	if( name == NULL )
	{
		BN_SendPrivateMessage( I, nick, "no filename specified." );
		return 1;
	}

	// dlopen...
	handle = dlopen( name, RTLD_LAZY );
	if( !handle )
	{
		sprintf( filename, "%s.so", name );
		handle = dlopen( filename, RTLD_LAZY );
	}
	else
		strcpy( filename, name );
	if( !handle )
	{
		BN_SendPrivateMessage( I, nick, "dlopen failed." );
		BN_SendPrivateMessage( I, nick, dlerror() );
		return 1;
	}

	// register handle of dlopen to the list
	if( addons == NULL )
	{
		addons = calloc( sizeof(*addons), 2 );
		addons[0].handle = handle;
		addons[0].filename = strdup( filename );
		addons[1].handle = NULL;
		addons[1].filename = NULL;
	}
	else
	{
		int a;

		for( a=0; addons[a].handle; a++ );
		addons = realloc( addons, sizeof(*addons)*(a+2) );
		addons[a].handle = handle;
		addons[a].filename = strdup( filename );
		addons[a+1].handle = NULL;
		addons[a+1].filename = NULL;
	}

	return 1;
}

static int def_detach( BN_PInfo I, const char *name, const char **args )
{
	char filename[strlen(name) + 32];
	char nick[64];
	char str[strlen(name) + 64];
	int a;

	BN_ExtractNick( args[0], nick, 64 );

	strcpy( filename, name );
	for( a=0; addons[a].handle; a++ )
	{
		if( !strcmp( addons[a].filename, filename ) )
			goto dodlclose;
	}

	sprintf( filename, "%s.so", name );
	for( a=0; addons[a].handle; a++ )
	{
		if( !strcmp( addons[a].filename, filename ) )
			goto dodlclose;
	}

	BN_SendPrivateMessage( I, nick, "no filename found." );

	return 1;

dodlclose:
	dlerror();

	if( dlclose( addons[a].handle ) )
	{
		BN_SendPrivateMessage( I, nick, "dlclose failed." );
		BN_SendPrivateMessage( I, nick, dlerror() );
	}

	do
	{
		addons[a] = addons[a+1];
		a ++;
	}
	while( addons[a+1].handle );

	sprintf( str, "%s detached.", filename );
	BN_SendPrivateMessage( I, nick, str );

	return 1;
}

static int def_PrivateTalk( BN_PInfo I, void *arg, const char **args )
{
	const struct
	{
		const char *string;
		int (*action)(BN_PInfo,const char **);
	} actions[] =
	{
		{ "handlers", def_list_event },
		{ "addon directory", def_list_plugindir },
		{ "exit", def_exit },
	};
#define actions_num	(sizeof(actions)/sizeof(actions[0]))
	int a;
	int ret = -1;
	char *message;
	char **argv;
	int argc;

	// check for complete string
	debug( "private talk from %s.(%s)\n", args[0], args[2] );
	for( a=0; a<actions_num; a++ )
	{
		if( !strcmp(actions[a].string,args[2]) )
		{
			if( actions[a].action(I,args) == 1 )
				return 1;
		}
	}

	// parse user message and make token
	message = strdup( args[2] );
	argc = parse_line( &message, &argv );
	if( argc > 0 )
	{
		if( argc == 2 )
		{
			if( !strcmp( argv[0], "attach" ) )
			{
				def_attach( I, argv[1], args );
				ret = 1;
			}
			else if( !strcmp( argv[0], "detach" ) )
			{
				def_detach( I, argv[1], args );
				ret = 1;
			}
		}
returnfunc:
		parse_line_free( argv );
		free( message );
	}

	return ret;
}

static struct _event_callback default_functions =
{
	.name		= "default functions",
	.eventname	= "PrivateTalk",
	.callback	= def_PrivateTalk,
	.arg		= NULL,
};

int init_default_functions( void )
{
	return register_event( &default_functions );
}

